<template>
  <transition name="fade">
    <div v-show="show" class="modal">
      <div class="modal-content">
        <div class="modal-header">
          <slot name="header"></slot>
        </div>
        <div class="modal-body">
          <slot></slot>
        </div>
        <div class="modal-footer">
          <slot name="footer"></slot>
        </div>
      </div>
    </div>
  </transition>
</template>

<script setup>
import { ref, defineExpose } from 'vue';

const show = ref(false);

const openModal = () => {
  show.value = true;
};

const closeModal = () => {
  show.value = false;
};

defineExpose({ openModal, closeModal });
</script>

<style lang="scss" scoped>
.modal {
  position: fixed;
  z-index: 9999;
  display: flex;
  align-items: center;
  justify-content: center;
  top: 0;
  left: 0;
  height: 100vh;
  width: 100%;
  background: rgba($color: #000000, $alpha: 0.3);

  &-content {
    width: 400px;
    height: 400px;
    border-radius: 20px;
    padding: 10px;
    background: #fff;
  }
}
</style>
